﻿using TribesPSO;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using System;

namespace TribesPSOTest
{
    
    
    /// <summary>
    ///This is a test class for EuclidianVectorBuilderTest and is intended
    ///to contain all EuclidianVectorBuilderTest Unit Tests
    ///</summary>
    [TestClass()]
    public class EuclidianVectorBuilderTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///A test for AddDimensionData
        ///</summary>
        [TestMethod()]
        public void AddDimensionDataTest()
        {
            EuclidianVectorBuilder target = new EuclidianVectorBuilder(); // TODO: Initialize to an appropriate value
            for (int n = 0; n < 10; n++)
            {
                target.AddDimensionData(n);
                Assert.AreEqual(n, target[n]);
            }
        }

        /// <summary>
        ///A test for ToEuclidianVector
        ///</summary>
        [TestMethod()]
        public void ToEuclidianVectorTest()
        {
            EuclidianVectorBuilder target = new EuclidianVectorBuilder();
            for (int n = 0; n <= 5; n++)
            {
                target.AddDimensionData(n);
            }
            EuclidianVector expected = new EuclidianVector(0, 1, 2, 3, 4, 5);
            EuclidianVector actual;
            actual = target.ToEuclidianVector();
            Assert.AreEqual(expected, actual);
        }

        /// <summary>
        ///A test for AddDimensionData
        ///</summary>
        [TestMethod()]
        public void AddDimensionDataToFrozenTest()
        {
            EuclidianVectorBuilder target = new EuclidianVectorBuilder();
            for (int n = 0; n <= 5; n++)
            {
                target.AddDimensionData(n);
            }
            target.ToEuclidianVector();
            try
            {
                target.AddDimensionData(3);
                Assert.Fail("Expected an invalidOperationException");
            }
            catch (InvalidOperationException)
            {

            }
            catch
            {
                Assert.Fail("Expected an invalidOperationException");
            }
        }
    }
}
