﻿using TribesPSO;
using NUnit.Framework;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace TribesPSOTest.NUnit
{


    /// <summary>
    ///This is a test class for GaussianRandomTest and is intended
    ///to contain all GaussianRandomTest Unit Tests
    ///</summary>
    [TestFixture()]
    public class GaussianRandomTest
    {


        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        // 
        //You can use the following additional attributes as you write your tests:
        //
        //Use ClassInitialize to run code before running the first test in the class
        //[ClassInitialize()]
        //public static void MyClassInitialize(TestContext testContext)
        //{
        //}
        //
        //Use ClassCleanup to run code after all tests in a class have run
        //[ClassCleanup()]
        //public static void MyClassCleanup()
        //{
        //}
        //
        //Use TestInitialize to run code before running each test
        //[TestInitialize()]
        //public void MyTestInitialize()
        //{
        //}
        //
        //Use TestCleanup to run code after each test has run
        //[TestCleanup()]
        //public void MyTestCleanup()
        //{
        //}
        //
        #endregion


        /// <summary>
        ///Quick and dirty test to make sure the distribution is roughly gaussian
        ///</summary>
        [Test()]
        public void NextGaussianTest()
        {
            int samples = 500000;

            GaussianRandom target = new GaussianRandom(); // TODO: Initialize to an appropriate value
            List<double> Generated = new List<double>();
            for (int n = 0; n < samples; n++)
            {
                Generated.Add(target.NextGaussian());
            }

            ImmutableGaussianCurve curve = new ImmutableGaussianCurve(0, 1);

            for (double n = -5; n <= 5; n += .1)
            {
                double hits = Generated.Count(o => (o >= (n - .1)) && (o <= (n + .1)));
                double GeneratedPDF = hits / (samples * .2);
                double CalculatedPDF = curve.Density(n);
                Assert.AreEqual(CalculatedPDF, GeneratedPDF, .01);
            }
        }
    }
}
